// GlobalError.cpp: implementation of the CGlobalError class.
//
// This source file is a supplement to the article "Digitalni zvuk". The article
// was published in the #34 issue of the "PC" computer monthly, published in
// Belgrade, Yugoslavia by "PC Press"
//
// You can freely use, modify and redistribute this file, provided that this
// header is kept unchanged
//
//                                                                 Ivica Nikolic
//                                                      ivica@galeb.etf.bg.ac.yu
//
////////////////////////////////////////////////////////////////////////////////


#include "StdInclude.h"

CGlobalError CGlobalError::g_Instance;

CGlobalError::CGlobalError()
{
	m_hEvent = CreateEvent( NULL, TRUE, FALSE, NULL );
}

CGlobalError::~CGlobalError()
{
	CloseHandle( m_hEvent );
}

HANDLE CGlobalError::GetHandle()
{
	return m_hEvent;
}

void CGlobalError::Raise()
{
	SetEvent( m_hEvent );
}

void CGlobalError::Reset()
{
	ResetEvent( m_hEvent );
}

BOOL CGlobalError::HasOccured()
{
	return ( WaitForSingleObject(m_hEvent, 0) == WAIT_OBJECT_0 );
}
