// ProcessorThread.h: interface for the CProcessorThread class.
//
// This source file is a supplement to the article "Digitalni zvuk". The article
// was published in the #34 issue of the "PC" computer monthly, published in
// Belgrade, Yugoslavia by "PC Press"
//
// You can freely use, modify and redistribute this file, provided that this
// header is kept unchanged
//
//                                                                 Ivica Nikolic
//                                                      ivica@galeb.etf.bg.ac.yu
//
////////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_PROCESSORTHREAD_H__CF4745ED_B04C_11D1_863D_000000000000__INCLUDED_)
#define AFX_PROCESSORTHREAD_H__CF4745ED_B04C_11D1_863D_000000000000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Thread.h"
#include "RecorderThread.h"
#include "PlayerThread.h"

class CProcessorThread : public CThread  
{
public:
	CProcessorThread(
		WAVEFORMATEX* pwfmt,
		UINT nBufferSize,
		CRecorderThread* pthrdRecorder,
		CPlayerThread* pthrdPlayer
	);
	virtual ~CProcessorThread();

	virtual void Run();

protected:
	void AdvanceToNextSample();
	void PutSample( short nSample );

	WAVEFORMATEX m_wfmt;
	UINT m_nBufferSize;

	CRecorderThread* m_pthrdRecorder;
	CPlayerThread* m_pthrdPlayer;

	short* m_pnInBuffer;
	UINT m_nNextInUnreadPos;

	short* m_pnOutBuffer;
	UINT m_nNextOutFreePos;

	UINT m_nHalfBufferSize;
};

#endif // !defined(AFX_PROCESSORTHREAD_H__CF4745ED_B04C_11D1_863D_000000000000__INCLUDED_)
