// RingBuffer.h: interface for the CRingBuffer class.
//
// This source file is a supplement to the article "Digitalni zvuk". The article
// was published in the #34 issue of the "PC" computer monthly, published in
// Belgrade, Yugoslavia by "PC Press"
//
// You can freely use, modify and redistribute this file, provided that this
// header is kept unchanged
//
//                                                                 Ivica Nikolic
//                                                      ivica@galeb.etf.bg.ac.yu
//
////////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_RINGBUFFER_H__AC4AD0F3_AEA4_11D1_8639_000000000000__INCLUDED_)
#define AFX_RINGBUFFER_H__AC4AD0F3_AEA4_11D1_8639_000000000000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CRingBuffer
{
public:
	CRingBuffer( UINT nBlockSize, UINT nBlocks );
	virtual ~CRingBuffer();

	void PutBlock( const BYTE* pb );
	void GetBlock( BYTE* pb );

	BOOL IsFull() const;
	BOOL IsEmpty() const;

	UINT GetNoOfFreeBlocks() const;
	UINT GetNoOfBlocksInBuffer() const;

private:
	BYTE** m_ppbBuffer;
	HANDLE m_hMutexBufferGuard;
	HANDLE m_hEventBufferNotFull;
	HANDLE m_hEventBufferNotEmpty;

	UINT m_nBlockSize;
	UINT m_nBlocks;

	UINT m_nNextFreePos;
	UINT m_nNextToReadPos;
};

#endif // !defined(AFX_RINGBUFFER_H__AC4AD0F3_AEA4_11D1_8639_000000000000__INCLUDED_)
