// WaveIOThread.h: interface for the CWaveIOThread class.
//
// This source file is a supplement to the article "Digitalni zvuk". The article
// was published in the #34 issue of the "PC" computer monthly, published in
// Belgrade, Yugoslavia by "PC Press"
//
// You can freely use, modify and redistribute this file, provided that this
// header is kept unchanged
//
//                                                                 Ivica Nikolic
//                                                      ivica@galeb.etf.bg.ac.yu
//
////////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_WAVEIOTHREAD_H__CF4745EE_B04C_11D1_863D_000000000000__INCLUDED_)
#define AFX_WAVEIOTHREAD_H__CF4745EE_B04C_11D1_863D_000000000000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Thread.h"
#include "RingBuffer.h"

class CWaveIOThread : public CThread
{
public:
	CWaveIOThread(
		WAVEFORMATEX* pwfmt,
		UINT nBufferSize,
		UINT nIOBuffers,
		UINT nRingBuffers
	);
	virtual ~CWaveIOThread();

	CRingBuffer* GetBuff();

protected:
	UINT WaitForEvent( BOOL& bShouldResetEvent );

	WAVEFORMATEX m_wfmt;
	UINT m_nBufferSize;
	UINT m_nIOBuffers;
	UINT m_nRingBuffers;

	WAVEHDR* m_pwhdrIOBuffers;
	BYTE** m_ppbIOBuffers;
	HANDLE m_hEventIOCompletion;

	HANDLE m_hEventsForWait[3];

	CRingBuffer m_buff;
};

#endif // !defined(AFX_WAVEIOTHREAD_H__CF4745EE_B04C_11D1_863D_000000000000__INCLUDED_)
